#include <stdlib.h>
#include <table.h>
#include <ndt.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>

unsigned int overwrite=0;

unsigned char *lut[100000]={0};

int each_property (eprop e, int *first)
{
  printf ("%c\"%s=%s\"",*first?',':' ',e->name,e->value);
  *first=1;
  return(1);
}

eprop allocate_prop(char *name,char *value)
{
  eprop e=(eprop)allocate_memory(sizeof(struct eprop));
  e->name=(char *)strdup(name);
  e->value=(char *)strdup(value);
  return(e);
}

void each_edge(void *context,table t)
{
  eprop srcas=(eprop)table_find(t,"src_as");
  eprop dstas=(eprop)table_find(t,"dst_as");
  eprop srcasn=(eprop)table_find(t,"src_asname");
  eprop dstasn=(eprop)table_find(t,"dst_asname");
  eprop as=(eprop)table_find(t,"as");
  eprop asn=(eprop)table_find(t,"asname");
  int first=0;

  if (srcas && (!srcasn || overwrite)) {
    if (lut[atoi(srcas->value)])
      table_insert(t,allocate_prop("src_asname",lut[atoi(srcas->value)]),"src_asname");
  }
  if (dstas && (!dstasn || overwrite)) {
    if (lut[atoi(dstas->value)])
      table_insert(t,allocate_prop("dst_asname",lut[atoi(dstas->value)]),"dst_asname");
  }
  if (as && (!asn || overwrite)) {
    if (lut[atoi(as->value)])
      table_insert(t,allocate_prop("asname",lut[atoi(as->value)]),"asname");
  }
  printf ("(");
  iterate_table_entries(t,each_property,&first);
  printf (")\n");
  destroy_ndt_edge(t);
}

main(int argc, char **argv)
{
  char aspath[255];
  char asname[255],*n;
  void (*commit)()=0;
  void *commit_context;
  unsigned int i,last=0;
  int this;
  int commit_count,commit_place;
  FILE *f;

  for (i=1;i<argc;i++){ 
    if (argv[i][0]=='-'){
      if (commit){
	(*commit)(commit_count,argv[commit_place],argv[commit_place+1]);
	commit=0;
      }
      if (strcmp(argv[i]+1,"overwrite")==0) overwrite=1;
      commit_place=i;
    } else commit_count++;
  }
  sprintf(aspath,"%s/%s",DATAPATH,"as2asname");
  if (!(f=fopen(aspath,"r"))){
    fprintf (stderr,"couldn't open %s\n",aspath);
    exit(1);
  }
  while (fscanf (f,"%d %s\n",&this,asname)==2){
    n=strdup(asname);
    if (this<0) for(i=last;i<=(-this);i++) lut[i]=n;
    else lut[this]=n;
    last=this;
  }
  if (commit)
    (*commit)(commit_count,argv[commit_place],argv[commit_place+1]); 
  read_ndt_file(0,each_edge);
}
