#include <stdlib.h>
#include <table.h>
#include <ndt.h>
#include <math.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>

int degree=2;
int recur=0;
typedef struct edge *edge;
char *spname="src_as";
char *dpname="dst_as";

struct edge {
  edge from_next;
  edge to_next;
  edge *from_last;
  edge *to_last;
  int live;
  table t;
};

typedef struct node {
  char *name;
  edge from;
  edge to;
  int count;
} *node;

int each_property (eprop e, int *first)
{
  printf ("%c\"%s=%s\"",*first?',':' ',e->name,e->value);
  *first=1;
  return(1);
}

eprop allocate_prop(char *name,char *value)
{
  eprop e=(eprop)allocate_memory(sizeof(struct eprop));
  e->name=(char *)strdup(name);
  e->value=(char *)strdup(value);
  return(e);
}

void each_edge(table nodes,table t)
{
  eprop sparam=(eprop)table_find(t,spname);
  eprop dparam=(eprop)table_find(t,dpname);
  char *sname,*dname;
  node s,d;
  edge e;

  if (sparam && dparam){
    sname=sparam->value;
    dname=dparam->value;
    if (!(s=(node)table_find(nodes,sname))){
      s=malloc(sizeof(struct node));
      s->name=sname;
      s->from=0;
      s->to=0;
      s->count=0;
      table_insert(nodes,s,sname);
    }
    if (!(d=(node)table_find(nodes,dname))){
      d=malloc(sizeof(struct node));
      d->name=dname;
      d->from=0;
      d->to=0;
      d->count=0;
      table_insert(nodes,d,dname);
    }
    e=malloc(sizeof(struct edge));
    e->t=t;
    e->live=1;
    d->count++;
    s->count++;
    if (e->from_next=s->from) e->from_next->from_last=&e->from_next;
    *(e->from_last=&s->from)=e;

    if (e->to_next=d->to) e->to_next->to_last=&e->to_next;
    *(e->to_last=&d->to)=e;
  }
}

int node_compare(node n, char *name)
{
  return(strcmp(n->name,name)==0);
}

void dump_node(node n,void *k)
{
  edge i;
  int first;
  for (i=n->to;i;i=i->to_next){
    if (i->live){
      printf ("(");
      first=0;
      iterate_table_entries(i->t,each_property,&first);
      printf (")\n");
    }
  }
}

int trim_node(node n,int *d)
{
  edge i;

  if (n->count < degree){
    *d=1;
    for (i=n->from;i;i=i->from_next) i->live=0;
/*      if (*i->to_last=i->to_next)
	i->to_next->to_last=i->to_last;*/

    for (i=n->to;i;i=i->to_next) i->live=0;
/*      if (*i->from_last=i->from_next)
	i->from_next->from_last=i->from_last;*/

/*   return(0);	 */
  }
  return(1);
}

void commit_int(int argc,int *n,char *foo,char *b)
{
  *n=atoi(b);
}

main(int argc, char **argv)
{
  table nodes;
  int d=1;
  void (*commit)()=0;
  void *commit_context;
  unsigned int i;
  int commit_count,commit_place;

  nodes=create_table(node_compare,key_from_string);
  for (i=1;i<argc;i++){ 
    if (argv[i][0]=='-'){
      if (commit)
	(*commit)(commit_count,commit_context,argv[commit_place],
		  argv[commit_place+1],
		  argv[commit_place+2],argv[commit_place+3]);
      commit=0;
      if (strcmp(argv[i]+1,"recur")==0) recur=1;
      if (strcmp(argv[i]+1,"degree")==0) {
	commit=commit_int;
	commit_context=&degree;
      }
      commit_count=0;
      commit_place=i;
    } else commit_count++;
  }
  if (commit)
    (*commit)(commit_count,commit_context,argv[commit_place],
	      argv[commit_place+1],
	      argv[commit_place+2],argv[commit_place+3]);
  read_ndt_file(0,each_edge,nodes);
  while (d){
    d=0;
    iterate_table_entries(nodes, trim_node,&d );
    if (!recur) d=0;
  }
  iterate_table_entries(nodes, dump_node,0 );
}
