#include <stdlib.h>
#include <table.h>
#include <ndt.h>
#include <math.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>

char *name;
float start=0.0;
float end=0.0;


float weight=1.0;

int each_property (eprop e, int *first)
{
  printf ("%c\"%s=%s\"",*first?',':' ',e->name,e->value);
  *first=1;
  return(1);
}

eprop allocate_prop(char *name,char *value)
{
  eprop e=(eprop)allocate_memory(sizeof(struct eprop));
  e->name=(char *)strdup(name);
  e->value=(char *)strdup(value);
  return(e);
}

void each_edge(void *context,table t)
{
  eprop param=(eprop)table_find(t,"delays");
  float k;
  char foo[128];
  float d[11];
  eprop z;
  int first=0;

  if (param){
    if (sscanf (param->value,"%f:%f:%f:%f:%f:%f:%f:%f:%f:%f:%f:%f",
		d,d+1,d+2,d+3,d+4,d+5,d+6,d+7,d+8,d+9,d+10)==11){
      sprintf (foo,"%f",d[6]-d[1]);
      z=allocate_prop("delay_spread",foo);
      table_insert(t,z,z->name);
    }
  }
  printf ("(");
  iterate_table_entries(t,each_property,&first);
  printf (")\n");
  destroy_ndt_edge(t);
}

void set_param(int c,char *foo,char *pname,char *min,char *max)
{
  start=atof(min);
  end=atof(max);
  name=strdup(pname);
}

void commit_start(int c,char *foo, char *r,char *g,char *b)
{
  start_red=atof(r);
  start_green=atof(g);
  start_blue=atof(b);
}

void commit_end(int c,char *foo, char *r,char *g,char *b)
{
  end_red=atof(r);
  end_green=atof(g);
  end_blue=atof(b);
}

void set_weight(int c,char *foo,char *w)
{
  weight=atof(w);
}

main(int argc, char **argv)
{
  void (*commit)()=0;
  void *commit_context;
  unsigned int i;
  int commit_count,commit_place;


  for (i=1;i<argc;i++){ 
    if (argv[i][0]=='-'){
      if (commit){
	(*commit)(commit_count,argv[commit_place],argv[commit_place+1],
		  argv[commit_place+2],argv[commit_place+3]);
	commit=0;
      }
      if (strcmp(argv[i]+1,"param")==0) commit=set_param;
      if (strcmp(argv[i]+1,"weight")==0) commit=set_weight;
      if (strcmp(argv[i]+1,"normalize")==0) normalize=1;
      if (strcmp(argv[i]+1,"supernormalize")==0) supernormalize=1;
      if (strcmp(argv[i]+1,"start")==0) commit=commit_start;
      if (strcmp(argv[i]+1,"end")==0) commit=commit_end;
      commit_count=0;
      commit_place=i;
    } else commit_count++;
  }
  if (commit)
    (*commit)(commit_count,argv[commit_place],argv[commit_place+1],
	      argv[commit_place+2],argv[commit_place+3]);
  read_ndt_file(0,each_edge);
}
