#include <stdlib.h>
#include <table.h>
#include <ndt.h>
#include <math.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>

char *sname;
char *dname;
float min=0.0;
float max=1.0;
float start=0.0;
float end=1.0;
float weight=1.0;
unsigned int normalize=0;
unsigned int supernormalize=0;

int each_property (eprop e, int *first)
{
  printf ("%c\"%s=%s\"",*first?',':' ',e->name,e->value);
  *first=1;
  return(1);
}

eprop allocate_prop(char *name,char *value)
{
  eprop e=(eprop)allocate_memory(sizeof(struct eprop));
  e->name=(char *)strdup(name);
  e->value=(char *)strdup(value);
  return(e);
}

void each_edge(void *context,table t)
{
  eprop param=(eprop)table_find(t,sname);
  float k,d;
  char foo[128];
  eprop z;
  int first=0;

  if (param){
    k=(atof(param->value)-start)/(end-start);
    k=(k>1.0)?1.0:k;
    k=(k<0.0)?0.0:k;
    k=pow(k,weight);
    d= k*(max-min)+min;
    sprintf (foo,"%f",d);
    z=allocate_prop(dname,foo);
    table_insert(t,z,z->name);
  }
  printf ("(");
  iterate_table_entries(t,each_property,&first);
  printf (")\n");
  destroy_ndt_edge(t);
}

void set_from(int c,char *foo,char *pname,char *min,char *max)
{
  start=atof(min);
  end=atof(max);
  sname=strdup(pname);
}

void set_to(int c,char *foo,char *idname,char *imin,char *imax)
{
  min=atof(imin);
  max=atof(imax);
  dname=strdup(idname);
}

void set_weight(int c,char *foo,char *w)
{
  weight=atof(w);
}

main(int argc, char **argv)
{
  void (*commit)()=0;
  void *commit_context;
  unsigned int i;
  int commit_count,commit_place;


  for (i=1;i<argc;i++){ 
    if (argv[i][0]=='-'){
      if (commit){
	(*commit)(commit_count,argv[commit_place],argv[commit_place+1],
		  argv[commit_place+2],argv[commit_place+3]);
	commit=0;
      }
      if (strcmp(argv[i]+1,"from")==0) commit=set_from;
      if (strcmp(argv[i]+1,"to")==0) commit=set_to;
      if (strcmp(argv[i]+1,"weight")==0) commit=set_weight;
      commit_count=0;
      commit_place=i;
    } else commit_count++;
  }
  if (commit)
    (*commit)(commit_count,argv[commit_place],argv[commit_place+1],
	      argv[commit_place+2],argv[commit_place+3]);
  read_ndt_file(0,each_edge);
}
