#include <table.h>
#include <ndt.h>
#include <fcntl.h>

unsigned int src=1;
unsigned int dest=1;
unsigned int overwrite=0;

unsigned int parse_ip(char *v)
{
  unsigned int a,b,c,d;
  sscanf(v,"%d.%d.%d.%d",&a,&b,&c,&d);
  a=((a<<24)|(b<<16)|(c<<8)|d);
  return(a);
}

eprop allocate_prop(char *name,char *value)
{
  eprop e=(eprop)allocate_memory(sizeof(struct eprop));
  e->name=(char *)strdup(name);
  e->value=(char *)strdup(value);
  return(e);
}

int each_property (eprop e, int *first)
{
  printf ("%c\"%s=%s\"",*first?',':' ',e->name,e->value);
  *first=1;
  return(1);
}

void each_edge(void *context,table t)
{
  int first=0;
  char *n;
  eprop srcip=(eprop)table_find(t,"srcip");
  eprop dstip=(eprop)table_find(t,"dstip");
  eprop srcplace=(eprop)table_find(t,"srcplace");
  eprop dstplace=(eprop)table_find(t,"dstplace");
  if (srcip && ((!srcplace) || overwrite)){
    if (n=(char *)resolve_ip_route(context,parse_ip(srcip->value)))
      table_insert(t,allocate_prop("srcplace",n),"srcplace");
  }
  if (dstip && ((!dstplace) || overwrite)){
    if (n=(char *)resolve_ip_route(context,parse_ip(dstip->value)))
      table_insert(t,allocate_prop("dstplace",n),"dstplace");
  }
  printf ("(");
  iterate_table_entries(t,each_property,&first);
  printf (")\n");
  destroy_ndt_edge(t);
}

void copy_string(int argc,char **context,char *prop,char *value)
{
  *context=(char *)strdup(value);
}

main(int argc, char **argv)
{
  void (*commit)()=0;
  void *commit_context;
  char buffer[512];
  char loadfile[128];
  char nametemp[128];
  unsigned int state=0,current=0,total=0,maskbits,namec=0;
  unsigned int i,cc;
  int fd;
  void *tree=0;
  int commit_count,commit_place;

  for (i=1;i<argc;i++){ 
    if (argv[i][0]=='-'){
      if (commit){
	(*commit)(commit_count,commit_context,argv[commit_place],
		  argv[commit_place+1]);
	commit=0;
      }
      if (strcmp(argv[i]+1,"src")==0) src=1;
      if (strcmp(argv[i]+1,"ip2place")==0) {
	commit_context=&loadfile;
	commit=copy_string;
      }
      if (strcmp(argv[i]+1,"dest")==0) dest=1;
      if (strcmp(argv[i]+1,"overwrite")==0) overwrite=1;

      commit_place=i;
    } else commit_count++;
  }
  if (commit)
    (*commit)(commit_count,commit_context,
	      argv[commit_place],argv[commit_place+1]); 
  sprintf(loadfile,"%s/ip2place",DATAPATH);
  if ((fd=open(loadfile,O_RDONLY))>=0){
    while ((cc=read(fd,buffer,512))>0){
      for(i=0;i<cc;i++){
	if (state==0){
	  switch(buffer[i]){
	  case '.':
	  case '/':
	    total=(total<<8)|current;
	    current=0;
	    break;
	  case ' ':
	  case 9:
	    maskbits=current;
	    state=1;
	    break;
	  case '1':
	  case '2':
	  case '3':
	  case '4':
	  case '5':
	  case '6':
	  case '7':
	  case '8':
	  case '9':
	  case '0':
	    current=current*10+buffer[i]-'0';
	    break;
	  default: 
	    printf ("ip2place syntax error\n");
	    break;
	  }
	}
	if ((state==1) && !((buffer[i]==' ')||(buffer[i]==9))) state=2; 
	if (state==2){
	  if (buffer[i]=='\n') {
	    nametemp[namec]=0;
	    add_route(&tree,total,maskbits,strdup(nametemp));
	    current=total=namec=state=0;
	  } else nametemp[namec++]=buffer[i];
	}
      }
    }
    read_ndt_file(0,each_edge,tree);
  } else printf ("couldn't load %s\n",loadfile);
}
