#!/usr/bin/perl

########################################################################
# hostresolve.perl:
#  input: lines of name/value pairs
#  output: same lines, with possible additional name/value pairs 
#   {src|dst}{lat|lon|place}:
#   latitudes, longitudes, and placenames if
#   we find the values in our hostname->placename->latlong databases
# tamara munzner
# 4/96
########################################################################

$netinfodir = "/mord/usr/home/yuri/netinfo";

open(JUNK, ">junk.res");
&snarffiles();
while (<STDIN>) {
    # deal with a series of items that look like this:
    # ( "name=val", "name2=val2", ...)
    undef(%items, @line);
    chop;
    @line = split('"');
    foreach $item (@line) {
	if ((!($item =~ /^\s*\,\s*$/)) &&
	    (($item =~ /=/))){
	    undef($lhs, $rhs);
	    $item =~ /\(?\s*([^=]*)=(.*)/;
	    $lhs = $1; $rhs = $2;
	    if (defined($lhs) && defined($rhs)) {
		eval "\$$lhs = \"$rhs\";";
	    }
	    $items{$lhs} = $rhs;
	}
    }
    # we may overwrite certain fields. 
    # since we're sorting the keys, we know that *{lat|lon|place}
    #  will arrive after *host, so our method is OK.
    undef($srclat, $srclon);
    undef($dstlat, $dstlon);
    undef(@overwrite);
    print "( ";
    $first=0;
    foreach $lhs reverse(sort keys %items) {
	undef(@newdata);
	$rhs = $items{$lhs};
	$rhs =~ s/\s+$//o;
	if ($lhs eq "srcplace") {
	    if ($srclat = $p2lat{"\L$rhs\E"}){
		$srclon = $p2lon{"\L$rhs\E"};
		printf " \"srclat=%4.3f\", \"srclon=%4.3f\"", $srclat, $srclon;
		push(@overwrite,"(srclat, srclon)");
	    }
	} elsif ($lhs eq "dstplace") {
	    if ($dstlat = $p2lat{"\L$rhs\E"}){
		$dstlon = $p2lon{"\L$rhs\E"};
		printf " \"dstlat=%4.3f\", \"dstlon=%4.3f\"", $dstlat, $dstlon;
		push(@overwrite,"(dstlat, dstlon)");
	    }
	} 
	if (!(scalar(grep(/$lhs/,@overwrite)))) {
	    if ($first == 0){
		$first=1;
	    } else {
		print ",";
	    }
	    print " \"$lhs=$rhs\"";
	}
    }
    print ") \n";
}


sub snarffiles {
    local($place, $lat, $long);

    open(P2L, "<$netinfodir/place2latlong");
    while (<P2L>) {    
	s/\s*#.*$//;
	next if /^\s*$/;
	($place, $lat, $long) = /^(.*)\s+([-0-9.]+)\s+([-0-9.]+)\s*$/o;
	$place =~ s/\s+$//o;
	$p2lat{"\L$place\E"} = $lat;
	$p2lon{"\L$place\E"} = $long;
    }
    close(P2L);
}


close(JUNK);
