#include <stdlib.h>
#include <table.h>
#include <ndt.h>
#include <math.h>
#include <sys/types.h>
#include <stdio.h>
#include <fcntl.h>

int anti;
int directed=0;
typedef struct edge *edge;
typedef struct node *node;
char *a_name,*b_name;
char *spname="srcnode";
char *dpname="dstnode";
table nodec,noded;

struct edge {
  edge from_next;
  edge to_next;
  edge *from_last;
  edge *to_last;
  node from,to;
  int live;
  table t;
};

struct node {
  char *name;
  edge from;
  edge to;
  int count;
};

int each_property (eprop e, int *first)
{
  printf ("%c\"%s=%s\"",*first?',':' ',e->name,e->value);
  *first=1;
  return(1);
}

eprop allocate_prop(char *name,char *value)
{
  eprop e=(eprop)allocate_memory(sizeof(struct eprop));
  e->name=(char *)strdup(name);
  e->value=(char *)strdup(value);
  return(e);
}

void insert_edge (node s,node d,table t)
{
  edge e=malloc(sizeof(struct edge));
  if (e->from_next=s->from) e->from_next->from_last=&e->from_next;
  *(e->from_last=&s->from)=e;
  
  if (e->to_next=d->to) e->to_next->to_last=&e->to_next;
  *(e->to_last=&d->to)=e;
  
  e->from=s;
  e->to=d;
  e->t=t;
  e->live=1;
}

node create_node(table t,char *name)
{
  node n=malloc(sizeof(struct node));
  n->name=name;
  n->from=0;
  n->to=0;
  n->count=0;
  table_insert(t,n,name);
  return(n);
}

void each_edge(table nodes,table t)
{
  eprop sparam=(eprop)table_find(t,spname);
  eprop dparam=(eprop)table_find(t,dpname);
  char *sname,*dname;
  node s,d;
  edge e;

  if (sparam && dparam){
    sname=sparam->value;
    dname=dparam->value;
    if (!(s=(node)table_find(nodes,sname)))
      s=create_node(nodes,sname);
    if (!(d=(node)table_find(nodes,dname)))
      d=create_node(nodes,dname);
    d->count++;
    s->count++;
    insert_edge(s,d,t);
  }
}

int node_compare(node n, char *name)
{
  return(strcmp(n->name,name)==0);
}

int check_edge(node s,node d)
{
  edge i;
  for (i=s->from;i;i=i->from_next)
    if (i->to==d) return(1);
  if (!directed)
    for (i=s->to;i;i=i->to_next)
      if (i->from==d) return(1);
  return(0);
}

void dump_node(node n,void *k)
{
  edge i;
  int first;
  for (i=n->to;i;i=i->to_next){
    if (i->live){
      printf ("(");
      first=0;
      iterate_table_entries(i->t,each_property,&first);
      printf (")\n");
    }
  }
}

int trim_node(node n,table other)
{
  edge i,j;
  node o,h,s,d,sa,da;
  int found;
  
  if (!(s=table_find(nodec,n->name)))
    s=create_node(nodec,n->name);
  if (!(sa=table_find(nodec,n->name)))
    sa=create_node(noded,n->name);
  o=table_find(other,n->name);
  for (i=n->from;i;i=i->from_next) {
    found=0;
    if ((h=table_find(other,i->to->name)) && o)
      for (j=o->from;j;j=j->from_next) 
	if (j->to==h) found=1;
    if ((!(directed || found)) && o)
      for (j=o->to;j;j=j->to_next) 
	if (j->from==h) found=1;
    if (found) {
      if (!(da=table_find(noded,i->to->name)))
	da=create_node(noded,i->to->name);
      if (!check_edge(sa,da))
	insert_edge(sa,da,i->t);
    } else {
      if (!(d=table_find(nodec,i->to->name)))
	d=create_node(nodec,i->to->name);
      if (!check_edge(s,d))
	insert_edge(s,d,i->t);
    }
  }
  return(1);
}

void commit_int(int argc,int *n,char *foo,char *b)
{
  *n=atoi(b);
}

void commit_string(int argc,char **n,char *foo,char *b)
{
  *n=(char *)strdup(b);
}

main(int argc, char **argv)
{
  table nodesa,nodesb;
  int d=1;
  table r[2];
  void (*commit)()=0;
  void *commit_context;
  unsigned int i,afd,bfd;
  int commit_count,commit_place;

  nodesa=create_table(node_compare,key_from_string);
  nodesb=create_table(node_compare,key_from_string);
  nodec=create_table(node_compare,key_from_string);
  noded=create_table(node_compare,key_from_string);
  for (i=1;i<argc;i++){ 
    if (argv[i][0]=='-'){
      if (commit)
	(*commit)(commit_count,commit_context,argv[commit_place],
		  argv[commit_place+1],
		  argv[commit_place+2],argv[commit_place+3]);
      commit=0;
      if (strcmp(argv[i]+1,"a")==0) {
	commit=commit_string;
	commit_context=&a_name;
      }
      if (strcmp(argv[i]+1,"b")==0) {
	commit=commit_string;
	commit_context=&b_name;
      }
      if (strcmp(argv[i]+1,"intersection")==0) anti=1;
      if (strcmp(argv[i]+1,"directed")==0) directed=1;
      commit_count=0;
      commit_place=i;
    } else commit_count++;
  }
  if (commit)
    (*commit)(commit_count,commit_context,argv[commit_place],
	      argv[commit_place+1],
	      argv[commit_place+2],argv[commit_place+3]);
  
  if ((afd=open(a_name,O_RDONLY))<0){
    fprintf (stderr,"couldn't open %s\n",a_name);
    exit(1);
  }
  if ((bfd=open(b_name,O_RDONLY))<0){
    fprintf (stderr,"couldn't open %s\n",b_name);
    exit(1);
  }
  read_ndt_file(afd,each_edge,nodesa);
  read_ndt_file(bfd,each_edge,nodesb);
  iterate_table_entries(nodesa, trim_node,nodesb);
  iterate_table_entries(nodesb, trim_node,nodesa);
  if (anti)
    iterate_table_entries(noded, dump_node,0 );
  else
    iterate_table_entries(nodec, dump_node,0 );
}
