#include <stdlib.h>
#include <table.h>
#include <ndt.h>
#include <math.h>
#include <sys/types.h>
#include <stdio.h>
#include <fcntl.h>

int directed=0;
typedef struct edge *edge;
typedef struct node *node;
char *spname="srcnode";
char *dpname="dstnode";
unsigned int node_count=1;

struct edge {
  edge from_next;
  edge to_next;
  edge *from_last;
  edge *to_last;
  node from,to;
  int live;
  table t;
};

struct node {
  char *name;
  edge from;
  edge to;
  int count;
  int number;
};

int each_property (eprop e, int *first)
{
  printf ("%c\"%s=%s\"",*first?',':' ',e->name,e->value);
  *first=1;
  return(1);
}

eprop allocate_prop(char *name,char *value)
{
  eprop e=(eprop)allocate_memory(sizeof(struct eprop));
  e->name=(char *)strdup(name);
  e->value=(char *)strdup(value);
  return(e);
}

void insert_edge (node s,node d,table t)
{
  edge e=malloc(sizeof(struct edge));
  if (e->from_next=s->from) e->from_next->from_last=&e->from_next;
  *(e->from_last=&s->from)=e;
  
  if (e->to_next=d->to) e->to_next->to_last=&e->to_next;
  *(e->to_last=&d->to)=e;
  
  e->from=s;
  e->to=d;
  e->t=t;
  e->live=1;
}

node create_node(table t,char *name)
{
  node n=malloc(sizeof(struct node));
  n->name=name;
  n->from=0;
  n->to=0;
  n->count=0;
  n->number=node_count++;
  table_insert(t,n,name);
  return(n);
}

void each_edge(table nodes,table t)
{
  eprop sparam=(eprop)table_find(t,spname);
  eprop dparam=(eprop)table_find(t,dpname);
  char *sname,*dname;
  node s,d;
  edge e;

  if (sparam && dparam){
    sname=sparam->value;
    dname=dparam->value;
    if (!(s=(node)table_find(nodes,sname)))
      s=create_node(nodes,sname);
    if (!(d=(node)table_find(nodes,dname)))
      d=create_node(nodes,dname);
    d->count++;
    s->count++;
    insert_edge(s,d,t);
  }
}

int node_compare(node n, char *name)
{
  return(strcmp(n->name,name)==0);
}


void output_graphed_node(node n,void *k)
{
  edge i;
  int first;
  eprop name;

  printf ("%d {$NP %d %d$} \"%s\"",n->number,random()%512,random()%512,
	  n->name);
  first=0;
  for (i=n->to;i;i=i->to_next)
    printf ("\n%d \"\"",i->from->number);
  printf (";\n");
}

void commit_int(int argc,int *n,char *foo,char *b)
{
  *n=atoi(b);
}

void commit_string(int argc,char **n,char *foo,char *b)
{
  *n=(char *)strdup(b);
}

main(int argc, char **argv)
{
  table nodes;
  int d=1;
  table r[2];
  void (*commit)()=0;
  void *commit_context;
  unsigned int i;
  int commit_count,commit_place;

  nodes=create_table(node_compare,key_from_string);
  for (i=1;i<argc;i++){ 
    if (argv[i][0]=='-'){
      if (commit)
	(*commit)(commit_count,commit_context,argv[commit_place],
		  argv[commit_place+1],
		  argv[commit_place+2],argv[commit_place+3]);
      commit=0;
      if (strcmp(argv[i]+1,"directed")==0) directed=1;
      commit_count=0;
      commit_place=i;
    } else commit_count++;
  }
  if (commit)
    (*commit)(commit_count,commit_context,argv[commit_place],
	      argv[commit_place+1],
	      argv[commit_place+2],argv[commit_place+3]);
  read_ndt_file(0,each_edge,nodes);
  printf ("GRAPH \"ndt files\" = UNDIRECTED\n");
  iterate_table_entries(nodes, output_graphed_node);
  printf ("END\n");
}
