#include <stdlib.h>
#include <table.h>
#include <ndt.h>
#include <math.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>

int degree=2;
int recur=0;
typedef struct edge *edge;
char *sparam,*dparam;

struct edge {
  edge from_next;
  edge to_next;
  edge *from_last;
  edge *to_last;
  table t;
};

typedef struct node {
  char *name;
  edge from;
  edge to;
  int count;
  table t;
} *node;

static int eprop_compare(eprop p,char *n)
{
  return(string_equal(p->name,n));
}

int each_property (eprop e, int *first)
{
  printf ("%c\"%s=%s\"",*first?',':' ',e->name,e->value);
  *first=1;
  return(1);
}

eprop allocate_prop(char *name,char *value)
{
  eprop e=(eprop)allocate_memory(sizeof(struct eprop));
  e->name=(char *)strdup(name);
  e->value=(char *)strdup(value);
  return(e);
}

void each_edge(table nodes,table t)
{
  eprop p;
  char *src=0,*dst=0;
  node s,d;
  edge e;


  if (!(p=table_find(t,"nodename"))){
    if (!(p=table_find(t,"srcnode"))){
      if (p=table_find(t,sparam)) {
	src=p->value;
      } else {
	if (p=table_find(t,"srchost")) {
	  src=p->value;
	} else {
	  if (p=table_find(t,"srcplace")) {
	    src=p->value;
	  } else {
	    if (p=table_find(t,"srcip")) {
	      src=p->value;
	    } else {
	      if (p=table_find(t,"src_asname")) {
		src=p->value;
	      } else {
		if (p=table_find(t,"src_as")) 
		  src=p->value;
	      }
	    }
	  }
	}
      }
    }
    if (!(p=table_find(t,"dstnode"))){
      if (p=table_find(t,dparam)) {
	dst=p->value;
      } else {
	if (p=table_find(t,"dstplace")) {
	  dst=p->value;
	} else {
	  if (p=table_find(t,"dsthost")) {
	    dst=p->value;
	  } else {
	    if (p=table_find(t,"dstip")) {
	      dst=p->value;
	    } else{
	      if (p=table_find(t,"dst_asname")) {
		dst=p->value;
	      } else {
		if (p=table_find(t,"dst_as")) 
		  dst=p->value;
	      }
	    }
	  }
	}
      }
    }
    if (src){
      if (!(s=(node)table_find(nodes,src))){
	s=malloc(sizeof(struct node));
	s->name=src;
	s->from=0;
	s->to=0;
	s->count=0;
	s->t=create_table(eprop_compare,key_from_string);
	table_insert(s->t,allocate_prop("nodename",src),src);
	table_insert(nodes,s,src);
      }
      table_insert(t,allocate_prop("srcnode",src),src);
    }
    if (dst){
      if (!(d=(node)table_find(nodes,dst))){
	d=malloc(sizeof(struct node));
	d->name=dst;
	d->from=0;
	d->to=0;
	d->count=0;
	d->t=create_table(eprop_compare,key_from_string);
	table_insert(d->t,allocate_prop("nodename",dst),dst);
	table_insert(nodes,d,dst);
      }
      table_insert(t,allocate_prop("dstnode",dst),dst);
    }
    if (s && d) {
      e=(edge)malloc(sizeof(struct edge));
      if (e->from_next=s->from) e->from_next->from_last=&e->from_next;
      *(e->from_last=&s->from)=e;
      if (e->to_next=d->to) e->to_next->to_last=&e->from_next;
      *(e->to_last=&d->to)=e;
      e->t=t;
    } else printf ("nodify error: not source and dest\n");
  }
}

int node_compare(node n, char *name)
{
  return(strcmp(n->name,name)==0);
}

void dump_node(node n,void *k)
{
  edge i;
  int first;
  for (i=n->to;i;i=i->to_next){
    printf ("(");
    first=0;
    iterate_table_entries(i->t,each_property,&first);
    printf (")\n");
  }
}

void dump_node_nodes(node n,void *k)
{
  int first;
  printf ("(");
  first=0;
  iterate_table_entries(n->t,each_property,&first);
  printf (")\n");
}


void commit_int(int argc,int *n,char *foo,char *b)
{
  *n=atoi(b);
}

void commit_string(int argc,char **n,char *foo,char *b)
{
  *n=strdup(b);
}

main(int argc, char **argv)
{
  table nodes;
  int d=1;
  void (*commit)()=0;
  void *commit_context;
  unsigned int i;
  int commit_count,commit_place;

  nodes=create_table(node_compare,key_from_string);
  for (i=1;i<argc;i++){ 
    if (argv[i][0]=='-'){
      if (commit)
	(*commit)(commit_count,commit_context,argv[commit_place],
		  argv[commit_place+1],
		  argv[commit_place+2],argv[commit_place+3]);
      commit=0;
      if (strcmp(argv[i]+1,"s")==0) {
	commit=commit_string;
	commit_context=&sparam;
      }
      if (strcmp(argv[i]+1,"d")==0) {
	commit=commit_string;
	commit_context=&dparam;
      }
      commit_count=0;
      commit_place=i;
    } else commit_count++;
  }
  if (commit)
    (*commit)(commit_count,commit_context,argv[commit_place],
	      argv[commit_place+1],
	      argv[commit_place+2],argv[commit_place+3]);
  read_ndt_file(0,each_edge,nodes);
  iterate_table_entries(nodes, dump_node_nodes,0 );
  iterate_table_entries(nodes, dump_node,0 );
}
