#include <stdlib.h>
#include <table.h>
#include <ndt.h>
#include <math.h>
#include <sys/types.h>
#include <sys/socket.h>


char *spname="delay_spread";

void each_edge(float *range,table t)
{
  static int first=1;
  eprop param=(eprop)table_find(t,spname);
  float d;

  if (param){
    d=atof(param->value);
    if (first){
      first=0;
      range[0]=range[1]=d;
    } else {

      range[0]=(range[0]>d)?d:range[0];
      range[1]=(range[1]<d)?d:range[1];
    }
  }
  destroy_ndt_edge(t);
}

void commit_param(int argc,void *foo,char *bar)
{
  spname=bar;
}

main(int argc, char **argv)
{
  table nodes;
  void (*commit)()=0;
  void *commit_context;
  unsigned int i;
  float range[2];
  int commit_count,commit_place;

  for (i=1;i<argc;i++){ 
    if (argv[i][0]=='-'){
      if (commit){
	(*commit)(commit_count,argv[commit_place],argv[commit_place+1],
		  argv[commit_place+2],argv[commit_place+3]);
	commit=0;
      }
      if (strcmp(argv[i]+1,"param")==0) commit=commit_param;
      commit_count=0;
      commit_place=i;
    } else commit_count++;
  }
  if (commit)
    (*commit)(commit_count,argv[commit_place],argv[commit_place+1],
	      argv[commit_place+2],argv[commit_place+3]);
  read_ndt_file(0,each_edge,range);
  printf ("%s: %f %f\n",spname,range[0],range[1]);
}
