#include <stdlib.h>
#include <table.h>
#include <ndt.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>

unsigned int silent=0;
unsigned int ip=0;
unsigned int host=0;
unsigned int checkip=0;
unsigned int checkname=0;
unsigned int always=0;
unsigned int src=1;
unsigned int dst=1;
unsigned int overwrite=0;

int each_property (eprop e, int *first)
{
  printf ("%c\"%s=%s\"",*first?',':' ',e->name,e->value);
  *first=1;
  return(1);
}

eprop allocate_prop(char *name)
{
  eprop e=(eprop)allocate_memory(sizeof(struct eprop));
  e->name=(char *)strdup(name);
  return(e);
}

void each_edge(void *context,table t)
{
  eprop srcip=(eprop)table_find(t,"srcip");
  eprop dstip=(eprop)table_find(t,"dstip");
  eprop srchost=(eprop)table_find(t,"srchost");
  eprop dsthost=(eprop)table_find(t,"dsthost");
  eprop srcplace=(eprop)table_find(t,"srcplace");
  eprop dstplace=(eprop)table_find(t,"dstplace");
  struct hostent *e;
  char *text;
  unsigned int z,a,b,c,d;
  int first=0;
  eprop new;

  if (ip){
    if (src && srchost && (!srcip || overwrite)) {
      if (e=gethostbyname(srchost->value)){
	if (srcip) free(srcip->value);
	else srcip=allocate_prop("srcip");
	srcip->value=malloc(20);
	z=*(unsigned int *)e->h_addr_list[0];
	z=htonl(z);
	sprintf(srcip->value,"%d.%d.%d.%d",z>>24,(z>>16)&255,
		(z>>8)&255,z&255);
	table_insert(t,srcip,srcip->name);
      }
    }
    if (dst && dsthost && (!dstip || overwrite)) {
      if (e=gethostbyname(dsthost->value)){
	if (dstip) free(dstip->value);
	else dstip=allocate_prop("dstip");
	dstip->value=malloc(20);
	z=*(unsigned int *)e->h_addr_list[0];
	z=htonl(z);
	sprintf(dstip->value,"%d.%d.%d.%d",z>>24,(z>>16)&255,
		(z>>8)&255,z&255);
	table_insert(t,dstip,dstip->name);
      }
    }
  }
  if (host){
    if (src && srcip && (!srchost || overwrite)) {
      sscanf(srcip->value,"%d.%d.%d.%d",&a,&b,&c,&d);
      z=htonl((a<<24)|(b<<16)|(c<<8)|d);
      if (e=gethostbyaddr((char *)&z, 4, AF_INET)){
	if (srchost) free(srchost->value);
	else srchost=allocate_prop("srchost");
	srchost->value=(char *)strdup(e->h_name);
	table_insert(t,srchost,srchost->name);
      }
    }
    if (dst && dstip && (!dsthost || overwrite)) {
      sscanf(dstip->value,"%d.%d.%d.%d",&a,&b,&c,&d);
      z=htonl((a<<24)|(b<<16)|(c<<8)|d);
      if (e=gethostbyaddr((char *)&z, 4, AF_INET)){
	if (dsthost) free(dsthost->value);
	else dsthost=allocate_prop("dsthost");
	dsthost->value=(char *)strdup(e->h_name);
	table_insert(t,dsthost,dsthost->name);
      }
    }
  }

  printf ("(");
  iterate_table_entries(t,each_property,&first);
  printf (")\n");
  destroy_ndt_edge(t);
}

main(int argc, char **argv)
{
  void (*commit)()=0;
  void *commit_context;
  unsigned int i;
  int commit_count,commit_place;


  for (i=1;i<argc;i++){ 
    if (argv[i][0]=='-'){
      if (commit){
	(*commit)(commit_count,argv[commit_place],argv[commit_place+1]);
	commit=0;
      }
      if (strcmp(argv[i]+1,"silent")==0) silent=1;
      if (strcmp(argv[i]+1,"ip")==0) ip=1;
      if (strcmp(argv[i]+1,"host")==0) host=1;
      if (strcmp(argv[i]+1,"checkip")==0) checkip=1;
      if (strcmp(argv[i]+1,"checkname")==0) checkname=1;
      if (strcmp(argv[i]+1,"always")==0) always=1;

      commit_place=i;
    } else commit_count++;
  }
  if (commit)
    (*commit)(commit_count,argv[commit_place],argv[commit_place+1]); 
  read_ndt_file(0,each_edge);
}
